package com.example.catchme;

import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Objects;

public class Gamer {

    private String nickname;
    private String hunter;
    private LinkedList<Integer> scores = new LinkedList();




    public Gamer(String nickname, String hunter) {
        this.nickname = nickname;
        this.hunter = hunter;
    }


    public String getNickname() {
        return nickname;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    public String getHunter() {
        return hunter;
    }

    public void setHunter(String hunter) {
        this.hunter = hunter;
    }

   public void addScore(String score){
        this.scores.add(Integer.parseInt(score));
   }

   public int getHighScore(){
        return Collections.max(this.scores);
   }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Gamer)) return false;
        Gamer gamer = (Gamer) o;
        return getNickname().equals(gamer.getNickname());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getNickname());
    }


}
