package com.example.catchme;

import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import android.content.SharedPreferences;
import android.os.Build;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.stream.Collectors;

public class HighScoresActivity extends AppCompatActivity {

    @RequiresApi(api = Build.VERSION_CODES.N)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_high_scores);

        ListView highScores = findViewById(R.id.highscoreslist);
        SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        LinkedList<String> infos = new LinkedList();


        if(sharedPref.getString("gamers","").length() < 5){
            infos.add("NO ONE HAS PLAYED YET");

        }else{
            String jsonGamers = sharedPref.getString("gamers","");
            Gson gson = new Gson();
            Type type = new TypeToken<LinkedList<Gamer>>() {}.getType();
            LinkedList<Gamer> gamers = gson.fromJson(jsonGamers, type);
            Collections.sort(gamers, Comparator.comparingInt(Gamer ::getHighScore).reversed());

            LinkedList<Gamer> high5 = gamers.stream().limit(5).collect(Collectors.toCollection(LinkedList::new));


            infos = high5.stream().map(g -> g.getNickname()+"          "+g.getHighScore()).collect(Collectors.toCollection(LinkedList::new));

        }

        //add elemmets to listview
        infos.addFirst("NICKNAME          Score");
        ArrayAdapter<String> arr = new ArrayAdapter<String>(
                    this,
                    R.layout.support_simple_spinner_dropdown_item,
                    infos.stream().toArray(String[]::new));

        highScores.setAdapter(arr);

    }


}