package com.example.catchme;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.LinkedList;

public class ScoreActivity extends AppCompatActivity {

    private Intent game;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_score);

        game = getIntent();

        TextView nickname = findViewById(R.id.nickname);
        nickname.setText(game.getStringExtra("nickname"));

        TextView score = findViewById(R.id.score);
        score.setText(game.getStringExtra("score"));

        //getting shared data
        SharedPreferences sharedPref = PreferenceManager.getDefaultSharedPreferences(this);
        String jsonGamers = sharedPref.getString("gamers","");
        Gson gson = new Gson();
        Type type = new TypeToken<LinkedList<Gamer>>() {}.getType();
        LinkedList<Gamer> gamers = gson.fromJson(jsonGamers, type);

        Gamer newGamer= new Gamer(game.getStringExtra("nickname"), game.getStringExtra("hunter"));

        //check if gamer exists
        boolean exists =false;
        for(Gamer g:gamers){
            if(g.equals(newGamer)){
                g.addScore(game.getStringExtra("score"));
                exists=true;
                break;
            }
        }


        if(!exists){
            newGamer.addScore(game.getStringExtra("score"));
            gamers.add(newGamer);
        }








        SharedPreferences.Editor editor = sharedPref.edit();

        String json = gson.toJson(gamers);

        editor.putString("gamers",  json);

        editor.putString("score",  game.getStringExtra("score"));
        editor.putString("nickname",  game.getStringExtra("nickname"));



        editor.apply();

    }



    public void tryAgain(View view){
        //get params from gameactivity
        Intent goAgain = new Intent(this, GameActivity.class);


        goAgain.putExtra("nickname", game.getStringExtra("nickname").toString());
        goAgain.putExtra("target", game.getStringExtra("target").toString());
        goAgain.putExtra("hunter", game.getStringExtra("hunter").toString());
        goAgain.putExtra("result", game.getStringExtra("result").toString());
        goAgain.putExtra("sound", game.getStringExtra("sound").toString());
        finish();
        startActivityForResult(goAgain, 123);



    }

    public void goToHome(View view){
        Intent goHome = new Intent(this, HomeActivity.class);
        goHome.putExtra("nickname", game.getStringExtra("nickname").toString());
        goHome.putExtra("score", game.getStringExtra("score").toString());
        finish();
        startActivityForResult(goHome, 94);


    }
}